Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.hardsoft
Class HardSoftScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<HardSoftScore>
          org.optaplanner.core.api.score.buildin.hardsoft.HardSoftScore

All Implemented Interfaces:
  Serializable, Comparable<HardSoftScore>, FeasibilityScore<HardSoftScore>, Score<HardSoftScore>

    public final class HardSoftScore

extends AbstractScore<HardSoftScore>
implements FeasibilityScore<HardSoftScore>

This `Score` is based on 2 levels of int constraints: hard and soft. Hard constraints have priority over soft constraints.

This class is immutable.

See Also:
  `Score`, Serialized Form

Method Summary
`HardSoftScore` | `add(HardSoftScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(HardSoftScore other)`
`HardSoftScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`int` | `getHardScore()` The total of the broken negative hard constraints and fulfilled positive hard constraints.
`int` | `getSoftScore()` The total of the broken negative soft constraints and fulfilled positive soft constraints.
`int` | `hashCode()`
`boolean` | `isFeasible()` A `Solution` is feasible if it has no broken hard constraints.
`HardSoftScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`HardSoftScore` | `negate()` Returns a Score whose value is (- this).
`static HardSoftScore` | `parseScore(String scoreString)`
`HardSoftScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`HardSoftScore` | `subtract(HardSoftScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of numbers representing the Score.
`String` | `toString()`
`static HardSoftScore` | `valueOf(int hardScore, int softScore)`

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, isCompatibleArithmeticArgument, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.api.score.Score
`isCompatibleArithmeticArgument`

Method Detail

### parseScore

    public static HardSoftScore parseScore(String scoreString)

### valueOf

    public static HardSoftScore valueOf(int hardScore,
                                        int softScore)

### getHardScore

    public int getHardScore()

  The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.

  Returns:
    higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

### getSoftScore

    public int getSoftScore()

  The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

  In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard score.

  Returns:
    higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

### isFeasible

    public boolean isFeasible()

  Description copied from interface: `FeasibilityScore`
  A `Solution` is feasible if it has no broken hard constraints.

  Specified by:
    `isFeasible` in interface `FeasibilityScore<HardSoftScore>`
  Returns:
    true if the hard score(s) is 0 or higher

### add

    public HardSoftScore add(HardSoftScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Specified by:
    `add` in interface `Score<HardSoftScore>`
  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public HardSoftScore subtract(HardSoftScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Specified by:
    `subtract` in interface `Score<HardSoftScore>`
  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public HardSoftScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Specified by:
    `multiply` in interface `Score<HardSoftScore>`
  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public HardSoftScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Specified by:
    `divide` in interface `Score<HardSoftScore>`
  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public HardSoftScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Specified by:
    `power` in interface `Score<HardSoftScore>`
  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### negate

    public HardSoftScore negate()

  Description copied from interface: `Score`
  Returns a Score whose value is (- this).

  Specified by:
    `negate` in interface `Score<HardSoftScore>`
  Returns:
    - this

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new int{-0, -7}

  Specified by:
    `toLevelNumbers` in interface `Score<HardSoftScore>`
  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(HardSoftScore other)

  Specified by:
    `compareTo` in interface `Comparable<HardSoftScore>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.